## taradino 20250816

=== CMakeLists.txt ===

cmake_minimum_required(VERSION 3.10)
project(taradino
	DESCRIPTION "SDL2 port of Rise of the Triad"
	HOMEPAGE_URL "https://github.com/fabiangreffrath/taradino/"
	LANGUAGES C
	VERSION 2025.08.16
)
configure_file(rott/version.h.in rott/version.h @ONLY)

option(TARADINO_ASAN "Use Address Sanitizer" OFF)
option(TARADINO_SHAREWARE "Build shareware version" OFF)
option(TARADINO_WARNINGS_AS_ERRORS "Treat all compiler warnings as errors" OFF)
set(TARADINO_DATADIR "" CACHE STRING "Game data file directory")
set(TARADINO_SUFFIX "" CACHE STRING "Executable file name suffix")

add_library(ASAN::ASAN IMPORTED INTERFACE)
target_compile_options(ASAN::ASAN INTERFACE -fsanitize=address $<$<NOT:$<COMPILE_LANG_AND_ID:C,MSVC>>:-fno-omit-frame-pointer>)
target_link_options(ASAN::ASAN INTERFACE -fsanitize=address)

find_package(SDL2 REQUIRED CONFIG REQUIRED COMPONENTS SDL2)
find_package(SDL2 REQUIRED CONFIG COMPONENTS SDL2main)
find_package(SDL2_mixer REQUIRED CONFIG REQUIRED COMPONENTS SDL2_mixer)

file(GLOB TARADINO_SOURCES "${PROJECT_SOURCE_DIR}/rott/*.c")

if(WIN32 OR MSVC OR CMAKE_SYSTEM_NAME STREQUAL "Windows")
	list(APPEND TARADINO_SOURCES "${PROJECT_SOURCE_DIR}/misc/taradino.rc")
endif()

string(LENGTH "${TARADINO_SUFFIX}" TARADINO_SUFFIX_LEN)
if(TARADINO_SUFFIX_LEN GREATER 0)
	string(CONCAT TARADINO_EXEC "${CMAKE_PROJECT_NAME}" "-" "${TARADINO_SUFFIX}")
endif()

if(${TARADINO_SHAREWARE})
	set(TARADINO_TITLE "Taradino (Shareware)")
else()
	set(TARADINO_TITLE "Taradino")
endif()

add_executable(taradino ${TARADINO_SOURCES})
target_link_libraries(taradino PRIVATE $<TARGET_NAME_IF_EXISTS:SDL2::SDL2main> SDL2::SDL2 SDL2_mixer::SDL2_mixer)
target_compile_definitions(taradino PRIVATE PACKAGE_STRING="${TARADINO_TITLE} ${CMAKE_PROJECT_VERSION}")
target_compile_definitions(taradino PRIVATE PACKAGE_TARNAME="${CMAKE_PROJECT_NAME}")
target_include_directories(taradino PRIVATE "${PROJECT_BINARY_DIR}/rott")
target_link_libraries(taradino PUBLIC $<$<BOOL:${TARADINO_ASAN}>:ASAN::ASAN>)

if(NOT DEFINED TARADINO_EXEC)
	set(TARADINO_EXEC taradino)
endif()

set_target_properties(taradino PROPERTIES OUTPUT_NAME ${TARADINO_EXEC})

set_target_properties(taradino PROPERTIES C_STANDARD_REQUIRED ON C_STANDARD 99)
if (MSVC)
	# silence warnings about POSIX functions
	target_compile_options(taradino PUBLIC -D_CRT_SECURE_NO_WARNINGS -D_CRT_NONSTDC_NO_WARNINGS -Dstrcasecmp=_stricmp -Dalloca=_alloca)
	# silence unsigned/signed and integer truncation warnings
	target_compile_options(taradino PRIVATE /wd4267 /wd4244)
endif()

if(${TARADINO_SHAREWARE})
	target_compile_definitions(taradino PRIVATE SHAREWARE=1)
endif()

if(${TARADINO_WARNINGS_AS_ERRORS})
	if(MSVC)
		target_compile_options(taradino PRIVATE /WX)
	else()
		target_compile_options(taradino PRIVATE -Werror)
	endif()
endif()

if(${TARADINO_DATADIR})
	target_compile_definitions(taradino PRIVATE DATADIR="${TARADINO_DATADIR}")
endif()

include(GNUInstallDirs)
if(WIN32)
	if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.21 AND NOT VCPKG_TOOLCHAIN)
		install(
			TARGETS taradino
			RUNTIME_DEPENDENCIES
			PRE_EXCLUDE_REGEXES "api-ms-" "ext-ms-"
			POST_EXCLUDE_REGEXES ".*system32/.*\\.dll"
			DIRECTORIES $<TARGET_FILE_DIR:taradino> $ENV{PATH}
			RUNTIME DESTINATION .
		)
	else()
		install(TARGETS taradino RUNTIME DESTINATION .)
	endif()
	install(FILES ${PROJECT_SOURCE_DIR}/COPYING DESTINATION .)
	install(FILES ${PROJECT_SOURCE_DIR}/README.md DESTINATION .)
else()
	configure_file(${PROJECT_SOURCE_DIR}/misc/taradino.desktop.in ${PROJECT_BINARY_DIR}/${TARADINO_EXEC}.desktop @ONLY)
	configure_file(${PROJECT_SOURCE_DIR}/doc/taradino.6.in ${PROJECT_BINARY_DIR}/${TARADINO_EXEC}.6 @ONLY)
	install(FILES ${PROJECT_BINARY_DIR}/${TARADINO_EXEC}.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
	install(FILES ${PROJECT_SOURCE_DIR}/misc/taradino.svg DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps RENAME ${TARADINO_EXEC}.svg)
	install(FILES ${PROJECT_BINARY_DIR}/${TARADINO_EXEC}.6 DESTINATION ${CMAKE_INSTALL_MANDIR}/man6)
	install(FILES ${PROJECT_SOURCE_DIR}/COPYING DESTINATION ${CMAKE_INSTALL_DOCDIR})
	install(FILES ${PROJECT_SOURCE_DIR}/README.md DESTINATION ${CMAKE_INSTALL_DOCDIR})
	install(TARGETS taradino DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

set(CPACK_GENERATOR ZIP)
set(CPACK_PACKAGE_NAME ${TARADINO_EXEC})
set(CPACK_SOURCE_GENERATOR TGZ ZIP)
set(CPACK_SOURCE_IGNORE_FILES "/.git/;/cmake-build/;/build/;/.vs/;/out/;CMakeSettings.json")
set(CPACK_STRIP_FILES TRUE)
include(CPack)

=== debian/changelog ===
taradino (20250816-3) unstable; urgency=medium

  * Update debian/copyright

 -- Fabian Greffrath <fabian@debian.org>  Tue, 14 Oct 2025 13:19:21 +0200

taradino (20250816-2) unstable; urgency=medium

  * Let the transitional rott package remove alternatives on upgrade
  * Link the icon for the Shareware version

 -- Fabian Greffrath <fabian@debian.org>  Sat, 16 Aug 2025 13:07:20 +0200

taradino (20250816-1) unstable; urgency=medium

  * New upstream version 20250816

 -- Fabian Greffrath <fabian@debian.org>  Sat, 16 Aug 2025 12:50:21 +0200

taradino (20250815-1) unstable; urgency=medium

  * Follow upstream's renaming of rott to taradino
  * New upstream version 20250815
  * Remove patches, they don't apply anymore
  * Build and install both flavours
  * Remove alternatives handling, both flavours are installed
    side-by-side
  * Bump Standards-Version to 4.7.2

 -- Fabian Greffrath <fabian@debian.org>  Fri, 15 Aug 2025 12:58:58 +0200

rott (20230810-1) unstable; urgency=medium

  * New upstream version 20230810.
  * Remove desktop-file.patch, applied upstream.

 -- Fabian Greffrath <fabian@debian.org>  Thu, 07 Sep 2023 21:53:44 +0200

rott (20211123-1) unstable; urgency=medium

  [ Jonathan Dowland ]
  * Remove myself from Uploaders.

  [ Fabian Greffrath ]
  * Update debian/watch file.
  * Switch to my own, still unnamed, SDL2-based fork
    (fixes: #1038552).
  * New upstream version 20211123.
  * Remove debian/gbp.conf file.
  * Remove no-files-found-dialog.patch, solved upstream.
  * Bump Build-Depends to SDL2 libraries.
  * Bump debhelper-compat to 13.
  * Bump Standards-Version to 4.6.2.
  * Bump Debian packaging copyright year.

 -- Fabian Greffrath <fabian@debian.org>  Tue, 27 Jun 2023 14:53:43 +0200

rott (1.1.2+svn287-3) unstable; urgency=medium

  * Team upload
  * Suggest kdialog instead of kde-baseapps-bin (see #885839)
  * Update Vcs-* to point to salsa.debian.org
  * Use https URLs for Homepage and Source
  * Use https for d/copyright Format
  * Standards-Version: 4.1.3 (no further changes)
  * Use debhelper compat level 11
    - Remove redundant dh-autoreconf build-dependency
  * Set Rules-Requires-Root to no
  * Enable full compiler hardening

 -- Simon McVittie <smcv@debian.org>  Mon, 15 Jan 2018 10:23:17 +0000

rott (1.1.2+svn287-2) unstable; urgency=medium

  * Show a dialog box if files are missing. Based on patches and
    wordings by Alexandre Detiste, thank you very much (Closes: #790407).
    + Replace the unhelpful "W_InitFiles: no files found" error message
      with instructions to read README.Debian.
    + Improve README.Debian with clear instructions on how to use
      game-data-packager to locate/download the game data, build the
      possible rott-*-data Debian package(s), and install it/them.
    + Add "Suggests: zenity | kde-baseapps-bin | x11-utils | libnotify-bin"
      for the supported dialog box applications.
  * Do not recommend any soundfont at all, leave this to the
    libsdl-mixer1.2 package.
  * Update Uploaders field and Debian packaging copyright with my
    <fabian@debian.org> address.
  * Remove rott.menu file and icons in XPM and PNG formats, install upstream's
    SVG icon.
  * Fix the rott.desktop file.
    + Remove hard-coded fullscreen mode and resolution.
    + Add keywords.

 -- Fabian Greffrath <fabian@debian.org>  Fri, 09 Oct 2015 09:09:40 +0200

rott (1.1.2+svn287-1) unstable; urgency=medium

  * New upstream SVN snapshot.
    + Remove all patches that were applied upstream.
    + Upstream switched build system to Autotools, add
      "Build-Depends: dh-autoreconf" and adapt debian/rules accordingly.
  * Add debian/README.source file to document how the Debian source
    tarball was created, add debian/gbp.conf file to force xz compression.
  * Bump Standards-Version to 3.9.6.
  * Move g-d-p from Depends to Recommends, drop virtual rott-data package from
    alternative dependencies.

 -- Fabian Greffrath <fabian+debian@greffrath.com>  Mon, 11 May 2015 14:23:27 +0200

rott (1.1.2-3) unstable; urgency=medium

  * Make the "commercial" variant recognize all supported
    multiplayer map files and set 'gamestate.Product' accordingly.
    This saves us from building the SUPERROTT and SITELICENSE variants
    which had their multiplayer map file names hard-coded.
    Adjust documentation and packaging accordingly.
  * Fix missing fog on level Foggy Mountain (Closes: #775530).
    Light level is calculated based on scaled texture and sprite height
    and is thus resolution-dependent, fix special-casing for fog.
    Thanks Alexandre Detiste for the bug report!
  * Fix scaling of the weapon sprite.
  * Fix scaling of the sky texture.

 -- Fabian Greffrath <fabian+debian@greffrath.com>  Thu, 30 Apr 2015 16:15:21 +0200

rott (1.1.2-2) unstable; urgency=low

  * Team upload.

  [ Fabian Greffrath ]
  * Remove "Recommends: timidity" and the corresponding advice in
    debian/README.Debian. Installing any package containing a soundfont
    should be sufficient for music playback to work (see #498984).
  * Run "wrap-and-sort -asb".
  * Fix a segfault in the Darian level, original bug report and patch
    by Luc Habert (Closes: #700977).
  * Color crosshair by player health.
  * Replace the icon with a self-drawn alternative in three different
    formats and provide a reproduction rule in debian/rules.
  * Enable parallel builds.
  * Correctly append to CFLAGS in debian/rules.
  * Fix conflicting types in variable declarations (Closes: #751510),
    thanks Michael Tautschnig.

  [ Stephen Kitt ]
  * Drop obsolete Lintian override; rott-sitelicense is no longer
    detected as an extra license file.
  * Use the canonical 1.0 copyright format URI.
  * Standards-Version 3.9.5, no further change required.

 -- Stephen Kitt <skitt@debian.org>  Wed, 18 Jun 2014 07:14:21 +0200

rott (1.1.2-1) unstable; urgency=low

  * Imported Upstream version 1.1.2
  * Update Vcs-* fields.
  * Remove all patches applied upstream.


=== debian/control ===
Source: taradino
Section: contrib/games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Fabian Greffrath <fabian@debian.org>,
 Evgeni Golov <evgeni@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libsdl2-mixer-dev,
 libsdl2-dev,
Rules-Requires-Root: no
Standards-Version: 4.7.2
Homepage: https://github.com/fabiangreffrath/taradino
Vcs-Git: https://salsa.debian.org/games-team/rott.git
Vcs-Browser: https://salsa.debian.org/games-team/rott

Package: taradino
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 game-data-packager
Breaks:
 rott (<< 20250815-1~),
Replaces:
 rott (<< 20250815-1~),
Description: SDL2 port of Rise of the Triad
 Rise of the Triad is a high quality, fast scrolling first-person perspective
 3D action game. It includes a lot of destructive enemies, an arsenal of
 weapons from simple pistols to missile launchers, life-preserving armor, traps
 and ambushes galore.
 .
 WARNING: Rise of the Triad features wanton and gratuitous violence.
 .
 This package contains no data files: use `game-data-packager' to generate
 a suitable data package from the publicly available "Rise of the Triad:
 The HUNT Begins" shareware episode.

Package: rott
Architecture: all
Multi-Arch: foreign
Section: contrib/oldlibs
Depends:
 taradino (>= 20250815-1~),
 ${misc:Depends}
Description: transitional dummy package (rott -> taradino)
 This package is a dummy package to enable the rott
 to taradino transition. It can be safely removed.

## taradino 20251031

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 	DESCRIPTION "SDL2 port of Rise of the Triad"
 	HOMEPAGE_URL "https://github.com/fabiangreffrath/taradino/"
 	LANGUAGES C
-	VERSION 2025.08.16
+	VERSION 2025.10.31
 )
 configure_file(rott/version.h.in rott/version.h @ONLY)
 
@@ -23,6 +23,7 @@
 find_package(SDL2_mixer REQUIRED CONFIG REQUIRED COMPONENTS SDL2_mixer)
 
 file(GLOB TARADINO_SOURCES "${PROJECT_SOURCE_DIR}/rott/*.c")
+file(GLOB TARADINO_HEADERS "${PROJECT_SOURCE_DIR}/rott/*.h")
 
 if(WIN32 OR MSVC OR CMAKE_SYSTEM_NAME STREQUAL "Windows")
 	list(APPEND TARADINO_SOURCES "${PROJECT_SOURCE_DIR}/misc/taradino.rc")
@@ -72,7 +73,7 @@
 	endif()
 endif()
 
-if(${TARADINO_DATADIR})
+if(NOT TARADINO_DATADIR STREQUAL "")
 	target_compile_definitions(taradino PRIVATE DATADIR="${TARADINO_DATADIR}")
 endif()
 
@@ -103,6 +104,14 @@
 	install(TARGETS taradino DESTINATION ${CMAKE_INSTALL_BINDIR})
 endif()
 
+find_program(CLANGFORMAT_EXECUTABLE clang-format)
+if(CLANGFORMAT_EXECUTABLE)
+	add_custom_target(clangformat
+		COMMAND ${CLANGFORMAT_EXECUTABLE} -style=file -i ${TARADINO_SOURCES} ${TARADINO_HEADERS}
+		WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
+	)
+endif()
+
 set(CPACK_GENERATOR ZIP)
 set(CPACK_PACKAGE_NAME ${TARADINO_EXEC})
 set(CPACK_SOURCE_GENERATOR TGZ ZIP)

=== debian/changelog ===
taradino (20251031-1) unstable; urgency=medium

  * New upstream version 20251031
  * Update debian/watch file to version 5
  * Remove redundant RRR: no

 -- Fabian Greffrath <fabian@debian.org>  Fri, 31 Oct 2025 12:14:25 +0100

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,6 @@
  debhelper-compat (= 13),
  libsdl2-mixer-dev,
  libsdl2-dev,
-Rules-Requires-Root: no
 Standards-Version: 4.7.2
 Homepage: https://github.com/fabiangreffrath/taradino
 Vcs-Git: https://salsa.debian.org/games-team/rott.git

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	# Both flavors are configured and built in the dh_auto_build target.

override_dh_auto_build:
	# Shareware Version
	dh_auto_configure -- \
		--fresh \
		-DCMAKE_INSTALL_BINDIR=games \
		-DTARADINO_SHAREWARE=ON \
		-DTARADINO_SUFFIX=shareware
	dh_auto_build

	# Commercial Version
	dh_auto_configure -- \
		--fresh \
		-DCMAKE_INSTALL_BINDIR=games \
		-DTARADINO_SHAREWARE=OFF \
		-UTARADINO_SUFFIX
	dh_auto_build

execute_after_dh_installdocs:
	find debian/ -name "COPYING*" -delete

=== debian/watch ===
Version: 5
Template: GitHub
Owner: fabiangreffrath
Project: taradino

## taradino 20251216

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,13 @@
+cmake_minimum_required(VERSION 3.10)
 
-cmake_minimum_required(VERSION 3.10)
+# Automatically installs dependencies.
+set(X_VCPKG_APPLOCAL_DEPS_INSTALL ON)
+
 project(taradino
 	DESCRIPTION "SDL2 port of Rise of the Triad"
 	HOMEPAGE_URL "https://github.com/fabiangreffrath/taradino/"
 	LANGUAGES C
-	VERSION 2025.10.31
+	VERSION 2025.12.16
 )
 configure_file(rott/version.h.in rott/version.h @ONLY)
 
@@ -18,9 +21,9 @@
 target_compile_options(ASAN::ASAN INTERFACE -fsanitize=address $<$<NOT:$<COMPILE_LANG_AND_ID:C,MSVC>>:-fno-omit-frame-pointer>)
 target_link_options(ASAN::ASAN INTERFACE -fsanitize=address)
 
-find_package(SDL2 REQUIRED CONFIG REQUIRED COMPONENTS SDL2)
-find_package(SDL2 REQUIRED CONFIG COMPONENTS SDL2main)
-find_package(SDL2_mixer REQUIRED CONFIG REQUIRED COMPONENTS SDL2_mixer)
+find_package(SDL2 REQUIRED CONFIG)
+find_package(SDL2_mixer REQUIRED CONFIG)
+find_package(libADLMIDI CONFIG)
 
 file(GLOB TARADINO_SOURCES "${PROJECT_SOURCE_DIR}/rott/*.c")
 file(GLOB TARADINO_HEADERS "${PROJECT_SOURCE_DIR}/rott/*.h")
@@ -41,11 +44,39 @@
 endif()
 
 add_executable(taradino ${TARADINO_SOURCES})
-target_link_libraries(taradino PRIVATE $<TARGET_NAME_IF_EXISTS:SDL2::SDL2main> SDL2::SDL2 SDL2_mixer::SDL2_mixer)
+target_link_libraries(taradino PRIVATE
+	$<TARGET_NAME_IF_EXISTS:SDL2::SDL2main>
+	$<IF:$<TARGET_EXISTS:SDL2::SDL2>,SDL2::SDL2,SDL2::SDL2-static>
+	$<IF:$<TARGET_EXISTS:SDL2_mixer::SDL2_mixer>,SDL2_mixer::SDL2_mixer,SDL2_mixer::SDL2_mixer-static>
+)
 target_compile_definitions(taradino PRIVATE PACKAGE_STRING="${TARADINO_TITLE} ${CMAKE_PROJECT_VERSION}")
 target_compile_definitions(taradino PRIVATE PACKAGE_TARNAME="${CMAKE_PROJECT_NAME}")
 target_include_directories(taradino PRIVATE "${PROJECT_BINARY_DIR}/rott")
 target_link_libraries(taradino PUBLIC $<$<BOOL:${TARADINO_ASAN}>:ASAN::ASAN>)
+
+include(CheckLibraryExists)
+check_library_exists(m pow "" HAVE_LIBM)
+if(HAVE_LIBM)
+	target_link_libraries(taradino PRIVATE m)
+endif()
+
+if(libADLMIDI_FOUND)
+	target_compile_definitions(taradino PRIVATE HAVE_ADLMIDI)
+	if(NOT TARGET libADLMIDI::ADLMIDI)
+		if(TARGET libADLMIDI::ADLMIDI_shared)
+			add_library(libADLMIDI::ADLMIDI ALIAS libADLMIDI::ADLMIDI_shared)
+		else()
+			add_library(libADLMIDI::ADLMIDI ALIAS libADLMIDI::ADLMIDI_static)
+		endif()
+	endif()
+	target_link_libraries(taradino PRIVATE libADLMIDI::ADLMIDI)
+endif()
+
+include(CheckIncludeFile)
+check_include_file("dirent.h" HAVE_DIRENT_H)
+if (HAVE_DIRENT_H)
+	target_compile_definitions(taradino PRIVATE HAVE_DIRENT_H)
+endif()
 
 if(NOT DEFINED TARADINO_EXEC)
 	set(TARADINO_EXEC taradino)
@@ -54,11 +85,13 @@
 set_target_properties(taradino PROPERTIES OUTPUT_NAME ${TARADINO_EXEC})
 
 set_target_properties(taradino PROPERTIES C_STANDARD_REQUIRED ON C_STANDARD 99)
-if (MSVC)
+if(MSVC)
 	# silence warnings about POSIX functions
 	target_compile_options(taradino PUBLIC -D_CRT_SECURE_NO_WARNINGS -D_CRT_NONSTDC_NO_WARNINGS -Dstrcasecmp=_stricmp -Dalloca=_alloca)
 	# silence unsigned/signed and integer truncation warnings
 	target_compile_options(taradino PRIVATE /wd4267 /wd4244)
+else()
+	target_compile_options(taradino PRIVATE -Wall)
 endif()
 
 if(${TARADINO_SHAREWARE})

=== debian/changelog ===
taradino (20251216-2) unstable; urgency=medium

  * Apply patch to properly clamp MusicMode values

 -- Fabian Greffrath <fabian@debian.org>  Fri, 19 Dec 2025 08:42:15 +0100

taradino (20251216-1) unstable; urgency=medium

  * New upstream version 20251216
  * Update debian/copyright

 -- Fabian Greffrath <fabian@debian.org>  Tue, 16 Dec 2025 11:27:12 +0100

## taradino 20251222

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 	DESCRIPTION "SDL2 port of Rise of the Triad"
 	HOMEPAGE_URL "https://github.com/fabiangreffrath/taradino/"
 	LANGUAGES C
-	VERSION 2025.12.16
+	VERSION 2025.12.22
 )
 configure_file(rott/version.h.in rott/version.h @ONLY)

=== debian/changelog ===
taradino (20251222-1) unstable; urgency=medium

  * New upstream version 20251222
  * Remove patches, applied upstream

 -- Fabian Greffrath <fabian@debian.org>  Tue, 23 Dec 2025 08:50:33 +0100
